#include <fstream>
#include <iostream>

#include <stdlib.h>
#include <string.h>

using namespace std;

int main(int argc, char *argv[])
{
const char *UserFile = ".speakupctl";
const char *SystemFile = "/etc/speakupctl.conf";

char fdata[7];
char a[7];
char b[7];
char ConfFile[100];

ifstream infile;
ofstream outfile;
int rate;
int punct;
int pitch;
int voice;
int vol;

if (argc < 2)
{
		cout << "usage:  " << argv[0] << " store|restore" << endl;
		return 1;
}
if (getuid() == 0)
{
strcpy(ConfFile, SystemFile);
}
else
{
strcpy(ConfFile, getenv("HOME"));
strcat(ConfFile, "/");
strcat(ConfFile, UserFile);
}
if(strcmp(argv[1], "store") == 0)
{
infile.open("/proc/speakup/punct", ios::in);
infile.get(fdata, 7);
infile.ignore(80, '\n');
infile.close();
punct = atoi(fdata);
infile.open("/proc/speakup/rate", ios::in);
infile.get(fdata, 7);
infile.ignore(80, '\n');
infile.close();
rate = atoi(fdata);
infile.open("/proc/speakup/pitch", ios::in);
infile.get(fdata, 7);
infile.ignore(80, '\n');
infile.close();
pitch = atoi(fdata);
infile.open("/proc/speakup/voice", ios::in);
infile.get(fdata, 7);
infile.ignore(80, '\n');
infile.close();
voice = atoi(fdata);
infile.open("/proc/speakup/vol", ios::in);
infile.get(fdata, 7);
infile.ignore(80, '\n');
infile.close();
vol = atoi(fdata);
outfile.open(ConfFile, ios::out);
if(outfile.bad())
{
cout << "can't write to " << ConfFile << endl;
exit(1);
}

outfile << "punct " << punct << endl;
outfile << "rate " << rate << endl;
outfile << "pitch " << pitch << endl;
outfile << "voice " << voice << endl;
outfile << "vol " << vol << endl;
outfile.close();
cout << "settings saved to " << ConfFile << endl;
}

if(strcmp(argv[1], "restore") == 0)
{
infile.open(ConfFile, ios::in);
if ((infile.bad()) && (getuid() != 0))
{
strcpy(ConfFile, SystemFile);
infile.open(ConfFile, ios::in);
}
if (infile.bad())
{
cout << "can't read " << ConfFile << endl;
exit(1);
}
while(infile.good())
{
infile >> a >> b;
if(strcmp(a, "rate") == 0)
{
outfile.open("/proc/speakup/rate", ios::out);
outfile << b;
outfile.close();
}
if(strcmp(a, "pitch") == 0)
{
outfile.open("/proc/speakup/pitch", ios::out);
outfile << b;
outfile.close();
}
if(strcmp(a, "voice") == 0)
{
outfile.open("/proc/speakup/voice", ios::out);
outfile << b;
outfile.close();
}
if(strcmp(a, "vol") == 0)
{
outfile.open("/proc/speakup/vol", ios::out);
outfile << b;
outfile.close();
}
if(strcmp(a, "punct") == 0)
{
outfile.open("/proc/speakup/punct", ios::out);
outfile << b;
outfile.close();
}
}
}
return 0;
}

